<?php

namespace Diamond\Infrastructure\Models\User\Base;

use \DateTime;
use \Exception;
use \PDO;
use Diamond\Infrastructure\Models\User\User as ChildUser;
use Diamond\Infrastructure\Models\User\UserQuery as ChildUserQuery;
use Diamond\Infrastructure\Models\UserGroup\UserGroup;
use Diamond\Infrastructure\Models\UserGroup\UserGroupQuery;
use Diamond\Infrastructure\Models\User\Map\UserTableMap;
use PartScanner\Infrastructure\Models\Chat\Chat;
use PartScanner\Infrastructure\Models\Chat\ChatQuery;
use PartScanner\Infrastructure\Models\ChatMessage\ChatMessage;
use PartScanner\Infrastructure\Models\ChatMessage\ChatMessageQuery;
use PartScanner\Infrastructure\Models\ChatMessage\Base\ChatMessage as BaseChatMessage;
use PartScanner\Infrastructure\Models\ChatMessage\Map\ChatMessageTableMap;
use PartScanner\Infrastructure\Models\Chat\Base\Chat as BaseChat;
use PartScanner\Infrastructure\Models\Chat\Map\ChatTableMap;
use PartScanner\Infrastructure\Models\Client\Client;
use PartScanner\Infrastructure\Models\Client\ClientQuery;
use PartScanner\Infrastructure\Models\ClientsUsersRel\ClientsUsersRel;
use PartScanner\Infrastructure\Models\ClientsUsersRel\ClientsUsersRelQuery;
use PartScanner\Infrastructure\Models\ClientsUsersRel\Base\ClientsUsersRel as BaseClientsUsersRel;
use PartScanner\Infrastructure\Models\ClientsUsersRel\Map\ClientsUsersRelTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveRecord\ActiveRecordInterface;
use Propel\Runtime\Collection\Collection;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\BadMethodCallException;
use Propel\Runtime\Exception\LogicException;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Parser\AbstractParser;
use Propel\Runtime\Util\PropelDateTime;

/**
 * Base class that represents a row from the '_users' table.
 *
 *
 *
 * @package    propel.generator.Diamond.Infrastructure.Models.User.Base
 */
abstract class User implements ActiveRecordInterface
{
    /**
     * TableMap class name
     *
     * @var string
     */
    public const TABLE_MAP = '\\Diamond\\Infrastructure\\Models\\User\\Map\\UserTableMap';


    /**
     * attribute to determine if this object has previously been saved.
     * @var bool
     */
    protected $new = true;

    /**
     * attribute to determine whether this object has been deleted.
     * @var bool
     */
    protected $deleted = false;

    /**
     * The columns that have been modified in current object.
     * Tracking modified columns allows us to only update modified columns.
     * @var array
     */
    protected $modifiedColumns = [];

    /**
     * The (virtual) columns that are added at runtime
     * The formatters can add supplementary columns based on a resultset
     * @var array
     */
    protected $virtualColumns = [];

    /**
     * The value for the id field.
     *
     * @var        int
     */
    protected $id;

    /**
     * The value for the name field.
     *
     * @var        string
     */
    protected $name;

    /**
     * The value for the email field.
     *
     * @var        string
     */
    protected $email;

    /**
     * The value for the password field.
     *
     * @var        string
     */
    protected $password;

    /**
     * The value for the activation field.
     *
     * @var        string
     */
    protected $activation;

    /**
     * The value for the group_id field.
     *
     * @var        int
     */
    protected $group_id;

    /**
     * The value for the usr_delete field.
     *
     * Note: this column has a database default value of: 0
     * @var        int
     */
    protected $usr_delete;

    /**
     * The value for the created_at field.
     *
     * Note: this column has a database default value of: (expression) CURRENT_TIMESTAMP
     * @var        DateTime
     */
    protected $created_at;

    /**
     * The value for the phone field.
     *
     * @var        string|null
     */
    protected $phone;

    /**
     * @var        UserGroup
     */
    protected $aUserGroup;

    /**
     * @var        ObjectCollection|ClientsUsersRel[] Collection to store aggregation of ClientsUsersRel objects.
     * @phpstan-var ObjectCollection&\Traversable<ClientsUsersRel> Collection to store aggregation of ClientsUsersRel objects.
     */
    protected $collClientsUsersRels;
    protected $collClientsUsersRelsPartial;

    /**
     * @var        ObjectCollection|Chat[] Collection to store aggregation of Chat objects.
     * @phpstan-var ObjectCollection&\Traversable<Chat> Collection to store aggregation of Chat objects.
     */
    protected $collChats;
    protected $collChatsPartial;

    /**
     * @var        ObjectCollection|ChatMessage[] Collection to store aggregation of ChatMessage objects.
     * @phpstan-var ObjectCollection&\Traversable<ChatMessage> Collection to store aggregation of ChatMessage objects.
     */
    protected $collChatMessages;
    protected $collChatMessagesPartial;

    /**
     * @var        ObjectCollection|Client[] Cross Collection to store aggregation of Client objects.
     * @phpstan-var ObjectCollection&\Traversable<Client> Cross Collection to store aggregation of Client objects.
     */
    protected $collClients;

    /**
     * @var bool
     */
    protected $collClientsPartial;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     *
     * @var bool
     */
    protected $alreadyInSave = false;

    /**
     * An array of objects scheduled for deletion.
     * @var ObjectCollection|Client[]
     * @phpstan-var ObjectCollection&\Traversable<Client>
     */
    protected $clientsScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var ObjectCollection|ClientsUsersRel[]
     * @phpstan-var ObjectCollection&\Traversable<ClientsUsersRel>
     */
    protected $clientsUsersRelsScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var ObjectCollection|Chat[]
     * @phpstan-var ObjectCollection&\Traversable<Chat>
     */
    protected $chatsScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var ObjectCollection|ChatMessage[]
     * @phpstan-var ObjectCollection&\Traversable<ChatMessage>
     */
    protected $chatMessagesScheduledForDeletion = null;

    /**
     * Applies default values to this object.
     * This method should be called from the object's constructor (or
     * equivalent initialization method).
     * @see __construct()
     */
    public function applyDefaultValues(): void
    {
        $this->usr_delete = 0;
    }

    /**
     * Initializes internal state of Diamond\Infrastructure\Models\User\Base\User object.
     * @see applyDefaults()
     */
    public function __construct()
    {
        $this->applyDefaultValues();
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return bool True if the object has been modified.
     */
    public function isModified(): bool
    {
        return !!$this->modifiedColumns;
    }

    /**
     * Has specified column been modified?
     *
     * @param string $col column fully qualified name (TableMap::TYPE_COLNAME), e.g. Book::AUTHOR_ID
     * @return bool True if $col has been modified.
     */
    public function isColumnModified(string $col): bool
    {
        return $this->modifiedColumns && isset($this->modifiedColumns[$col]);
    }

    /**
     * Get the columns that have been modified in this object.
     * @return array A unique list of the modified column names for this object.
     */
    public function getModifiedColumns(): array
    {
        return $this->modifiedColumns ? array_keys($this->modifiedColumns) : [];
    }

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return bool True, if the object has never been persisted.
     */
    public function isNew(): bool
    {
        return $this->new;
    }

    /**
     * Setter for the isNew attribute.  This method will be called
     * by Propel-generated children and objects.
     *
     * @param bool $b the state of the object.
     */
    public function setNew(bool $b): void
    {
        $this->new = $b;
    }

    /**
     * Whether this object has been deleted.
     * @return bool The deleted state of this object.
     */
    public function isDeleted(): bool
    {
        return $this->deleted;
    }

    /**
     * Specify whether this object has been deleted.
     * @param bool $b The deleted state of this object.
     * @return void
     */
    public function setDeleted(bool $b): void
    {
        $this->deleted = $b;
    }

    /**
     * Sets the modified state for the object to be false.
     * @param string $col If supplied, only the specified column is reset.
     * @return void
     */
    public function resetModified(?string $col = null): void
    {
        if (null !== $col) {
            unset($this->modifiedColumns[$col]);
        } else {
            $this->modifiedColumns = [];
        }
    }

    /**
     * Compares this with another <code>User</code> instance.  If
     * <code>obj</code> is an instance of <code>User</code>, delegates to
     * <code>equals(User)</code>.  Otherwise, returns <code>false</code>.
     *
     * @param mixed $obj The object to compare to.
     * @return bool Whether equal to the object specified.
     */
    public function equals($obj): bool
    {
        if (!$obj instanceof static) {
            return false;
        }

        if ($this === $obj) {
            return true;
        }

        if (null === $this->getPrimaryKey() || null === $obj->getPrimaryKey()) {
            return false;
        }

        return $this->getPrimaryKey() === $obj->getPrimaryKey();
    }

    /**
     * Get the associative array of the virtual columns in this object
     *
     * @return array
     */
    public function getVirtualColumns(): array
    {
        return $this->virtualColumns;
    }

    /**
     * Checks the existence of a virtual column in this object
     *
     * @param string $name The virtual column name
     * @return bool
     */
    public function hasVirtualColumn(string $name): bool
    {
        return array_key_exists($name, $this->virtualColumns);
    }

    /**
     * Get the value of a virtual column in this object
     *
     * @param string $name The virtual column name
     * @return mixed
     *
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function getVirtualColumn(string $name)
    {
        if (!$this->hasVirtualColumn($name)) {
            throw new PropelException(sprintf('Cannot get value of nonexistent virtual column `%s`.', $name));
        }

        return $this->virtualColumns[$name];
    }

    /**
     * Set the value of a virtual column in this object
     *
     * @param string $name The virtual column name
     * @param mixed $value The value to give to the virtual column
     *
     * @return $this The current object, for fluid interface
     */
    public function setVirtualColumn(string $name, $value)
    {
        $this->virtualColumns[$name] = $value;

        return $this;
    }

    /**
     * Logs a message using Propel::log().
     *
     * @param string $msg
     * @param int $priority One of the Propel::LOG_* logging levels
     * @return void
     */
    protected function log(string $msg, int $priority = Propel::LOG_INFO): void
    {
        Propel::log(get_class($this) . ': ' . $msg, $priority);
    }

    /**
     * Export the current object properties to a string, using a given parser format
     * <code>
     * $book = BookQuery::create()->findPk(9012);
     * echo $book->exportTo('JSON');
     *  => {"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * @param \Propel\Runtime\Parser\AbstractParser|string $parser An AbstractParser instance, or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param bool $includeLazyLoadColumns (optional) Whether to include lazy load(ed) columns. Defaults to TRUE.
     * @param string $keyType (optional) One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME, TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM. Defaults to TableMap::TYPE_PHPNAME.
     * @return string The exported data
     */
    public function exportTo($parser, bool $includeLazyLoadColumns = true, string $keyType = TableMap::TYPE_PHPNAME): string
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        return $parser->fromArray($this->toArray($keyType, $includeLazyLoadColumns, array(), true));
    }

    /**
     * Clean up internal collections prior to serializing
     * Avoids recursive loops that turn into segmentation faults when serializing
     *
     * @return array<string>
     */
    public function __sleep(): array
    {
        $this->clearAllReferences();

        $cls = new \ReflectionClass($this);
        $propertyNames = [];
        $serializableProperties = array_diff($cls->getProperties(), $cls->getProperties(\ReflectionProperty::IS_STATIC));

        foreach($serializableProperties as $property) {
            $propertyNames[] = $property->getName();
        }

        return $propertyNames;
    }

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Get the [name] column value.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Get the [email] column value.
     *
     * @return string
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * Get the [password] column value.
     *
     * @return string
     */
    public function getPassword()
    {
        return $this->password;
    }

    /**
     * Get the [activation] column value.
     *
     * @return string
     */
    public function getActivation()
    {
        return $this->activation;
    }

    /**
     * Get the [group_id] column value.
     *
     * @return int
     */
    public function getGroupId()
    {
        return $this->group_id;
    }

    /**
     * Get the [usr_delete] column value.
     *
     * @return int
     */
    public function getUsrDelete()
    {
        return $this->usr_delete;
    }

    /**
     * Get the [optionally formatted] temporal [created_at] column value.
     *
     *
     * @param string|null $format The date/time format string (either date()-style or strftime()-style).
     *   If format is NULL, then the raw DateTime object will be returned.
     *
     * @return string|DateTime Formatted date/time value as string or DateTime object (if format is NULL), and 0 if column value is 0000-00-00 00:00:00.
     *
     * @throws \Propel\Runtime\Exception\PropelException - if unable to parse/validate the date/time value.
     *
     * @psalm-return ($format is null ? DateTime : string)
     */
    public function getCreatedAt($format = null)
    {
        if ($format === null) {
            return $this->created_at;
        } else {
            return $this->created_at instanceof \DateTimeInterface ? $this->created_at->format($format) : null;
        }
    }

    /**
     * Get the [phone] column value.
     *
     * @return string|null
     */
    public function getPhone()
    {
        return $this->phone;
    }

    /**
     * Set the value of [id] column.
     *
     * @param int $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[UserTableMap::COL_ID] = true;
        }

        return $this;
    }

    /**
     * Set the value of [name] column.
     *
     * @param string $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setName($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->name !== $v) {
            $this->name = $v;
            $this->modifiedColumns[UserTableMap::COL_NAME] = true;
        }

        return $this;
    }

    /**
     * Set the value of [email] column.
     *
     * @param string $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setEmail($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->email !== $v) {
            $this->email = $v;
            $this->modifiedColumns[UserTableMap::COL_EMAIL] = true;
        }

        return $this;
    }

    /**
     * Set the value of [password] column.
     *
     * @param string $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setPassword($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->password !== $v) {
            $this->password = $v;
            $this->modifiedColumns[UserTableMap::COL_PASSWORD] = true;
        }

        return $this;
    }

    /**
     * Set the value of [activation] column.
     *
     * @param string $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setActivation($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->activation !== $v) {
            $this->activation = $v;
            $this->modifiedColumns[UserTableMap::COL_ACTIVATION] = true;
        }

        return $this;
    }

    /**
     * Set the value of [group_id] column.
     *
     * @param int $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setGroupId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->group_id !== $v) {
            $this->group_id = $v;
            $this->modifiedColumns[UserTableMap::COL_GROUP_ID] = true;
        }

        if ($this->aUserGroup !== null && $this->aUserGroup->getId() !== $v) {
            $this->aUserGroup = null;
        }

        return $this;
    }

    /**
     * Set the value of [usr_delete] column.
     *
     * @param int $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setUsrDelete($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->usr_delete !== $v) {
            $this->usr_delete = $v;
            $this->modifiedColumns[UserTableMap::COL_USR_DELETE] = true;
        }

        return $this;
    }

    /**
     * Sets the value of [created_at] column to a normalized version of the date/time value specified.
     *
     * @param string|integer|\DateTimeInterface $v string, integer (timestamp), or \DateTimeInterface value.
     *               Empty strings are treated as NULL.
     * @return $this The current object (for fluent API support)
     */
    public function setCreatedAt($v)
    {
        $dt = PropelDateTime::newInstance($v, null, 'DateTime');
        if ($this->created_at !== null || $dt !== null) {
            if ($this->created_at === null || $dt === null || $dt->format("Y-m-d H:i:s.u") !== $this->created_at->format("Y-m-d H:i:s.u")) {
                $this->created_at = $dt === null ? null : clone $dt;
                $this->modifiedColumns[UserTableMap::COL_CREATED_AT] = true;
            }
        } // if either are not null

        return $this;
    }

    /**
     * Set the value of [phone] column.
     *
     * @param string|null $v New value
     * @return $this The current object (for fluent API support)
     */
    public function setPhone($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->phone !== $v) {
            $this->phone = $v;
            $this->modifiedColumns[UserTableMap::COL_PHONE] = true;
        }

        return $this;
    }

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return bool Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues(): bool
    {
            if ($this->usr_delete !== 0) {
                return false;
            }

        // otherwise, everything was equal, so return TRUE
        return true;
    }

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array $row The row returned by DataFetcher->fetch().
     * @param int $startcol 0-based offset column which indicates which resultset column to start with.
     * @param bool $rehydrate Whether this object is being re-hydrated from the database.
     * @param string $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                  One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                            TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @return int next starting column
     * @throws \Propel\Runtime\Exception\PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate(array $row, int $startcol = 0, bool $rehydrate = false, string $indexType = TableMap::TYPE_NUM): int
    {
        try {

            $col = $row[TableMap::TYPE_NUM == $indexType ? 0 + $startcol : UserTableMap::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)];
            $this->id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 1 + $startcol : UserTableMap::translateFieldName('Name', TableMap::TYPE_PHPNAME, $indexType)];
            $this->name = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 2 + $startcol : UserTableMap::translateFieldName('Email', TableMap::TYPE_PHPNAME, $indexType)];
            $this->email = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 3 + $startcol : UserTableMap::translateFieldName('Password', TableMap::TYPE_PHPNAME, $indexType)];
            $this->password = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 4 + $startcol : UserTableMap::translateFieldName('Activation', TableMap::TYPE_PHPNAME, $indexType)];
            $this->activation = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 5 + $startcol : UserTableMap::translateFieldName('GroupId', TableMap::TYPE_PHPNAME, $indexType)];
            $this->group_id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 6 + $startcol : UserTableMap::translateFieldName('UsrDelete', TableMap::TYPE_PHPNAME, $indexType)];
            $this->usr_delete = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 7 + $startcol : UserTableMap::translateFieldName('CreatedAt', TableMap::TYPE_PHPNAME, $indexType)];
            if ($col === '0000-00-00 00:00:00') {
                $col = null;
            }
            $this->created_at = (null !== $col) ? PropelDateTime::newInstance($col, null, 'DateTime') : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 8 + $startcol : UserTableMap::translateFieldName('Phone', TableMap::TYPE_PHPNAME, $indexType)];
            $this->phone = (null !== $col) ? (string) $col : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }

            return $startcol + 9; // 9 = UserTableMap::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException(sprintf('Error populating %s object', '\\Diamond\\Infrastructure\\Models\\User\\User'), 0, $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws \Propel\Runtime\Exception\PropelException
     * @return void
     */
    public function ensureConsistency(): void
    {
        if ($this->aUserGroup !== null && $this->group_id !== $this->aUserGroup->getId()) {
            $this->aUserGroup = null;
        }
    }

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param bool $deep (optional) Whether to also de-associated any related objects.
     * @param ConnectionInterface $con (optional) The ConnectionInterface connection to use.
     * @return void
     * @throws \Propel\Runtime\Exception\PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload(bool $deep = false, ?ConnectionInterface $con = null): void
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(UserTableMap::DATABASE_NAME);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $dataFetcher = ChildUserQuery::create(null, $this->buildPkeyCriteria())->setFormatter(ModelCriteria::FORMAT_STATEMENT)->find($con);
        $row = $dataFetcher->fetch();
        $dataFetcher->close();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true, $dataFetcher->getIndexType()); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->aUserGroup = null;
            $this->collClientsUsersRels = null;

            $this->collChats = null;

            $this->collChatMessages = null;

            $this->collClients = null;
        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param ConnectionInterface $con
     * @return void
     * @throws \Propel\Runtime\Exception\PropelException
     * @see User::setDeleted()
     * @see User::isDeleted()
     */
    public function delete(?ConnectionInterface $con = null): void
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(UserTableMap::DATABASE_NAME);
        }

        $con->transaction(function () use ($con) {
            $deleteQuery = ChildUserQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $this->setDeleted(true);
            }
        });
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param ConnectionInterface $con
     * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws \Propel\Runtime\Exception\PropelException
     * @see doSave()
     */
    public function save(?ConnectionInterface $con = null): int
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($this->alreadyInSave) {
            return 0;
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(UserTableMap::DATABASE_NAME);
        }

        return $con->transaction(function () use ($con) {
            $ret = $this->preSave($con);
            $isInsert = $this->isNew();
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                UserTableMap::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }

            return $affectedRows;
        });
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param ConnectionInterface $con
     * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws \Propel\Runtime\Exception\PropelException
     * @see save()
     */
    protected function doSave(ConnectionInterface $con): int
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // We call the save method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aUserGroup !== null) {
                if ($this->aUserGroup->isModified() || $this->aUserGroup->isNew()) {
                    $affectedRows += $this->aUserGroup->save($con);
                }
                $this->setUserGroup($this->aUserGroup);
            }

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                    $affectedRows += 1;
                } else {
                    $affectedRows += $this->doUpdate($con);
                }
                $this->resetModified();
            }

            if ($this->clientsScheduledForDeletion !== null) {
                if (!$this->clientsScheduledForDeletion->isEmpty()) {
                    $pks = [];
                    foreach ($this->clientsScheduledForDeletion as $entry) {
                        $entryPk = [];

                        $entryPk[1] = $this->getId();
                        $entryPk[0] = $entry->getId();
                        $pks[] = $entryPk;
                    }

                    \PartScanner\Infrastructure\Models\ClientsUsersRel\ClientsUsersRelQuery::create()
                        ->filterByPrimaryKeys($pks)
                        ->delete($con);

                    $this->clientsScheduledForDeletion = null;
                }

            }

            if ($this->collClients) {
                foreach ($this->collClients as $client) {
                    if (!$client->isDeleted() && ($client->isNew() || $client->isModified())) {
                        $client->save($con);
                    }
                }
            }


            if ($this->clientsUsersRelsScheduledForDeletion !== null) {
                if (!$this->clientsUsersRelsScheduledForDeletion->isEmpty()) {
                    \PartScanner\Infrastructure\Models\ClientsUsersRel\ClientsUsersRelQuery::create()
                        ->filterByPrimaryKeys($this->clientsUsersRelsScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->clientsUsersRelsScheduledForDeletion = null;
                }
            }

            if ($this->collClientsUsersRels !== null) {
                foreach ($this->collClientsUsersRels as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->chatsScheduledForDeletion !== null) {
                if (!$this->chatsScheduledForDeletion->isEmpty()) {
                    \PartScanner\Infrastructure\Models\Chat\ChatQuery::create()
                        ->filterByPrimaryKeys($this->chatsScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->chatsScheduledForDeletion = null;
                }
            }

            if ($this->collChats !== null) {
                foreach ($this->collChats as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->chatMessagesScheduledForDeletion !== null) {
                if (!$this->chatMessagesScheduledForDeletion->isEmpty()) {
                    foreach ($this->chatMessagesScheduledForDeletion as $chatMessage) {
                        // need to save related object because we set the relation to null
                        $chatMessage->save($con);
                    }
                    $this->chatMessagesScheduledForDeletion = null;
                }
            }

            if ($this->collChatMessages !== null) {
                foreach ($this->collChatMessages as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    }

    /**
     * Insert the row in the database.
     *
     * @param ConnectionInterface $con
     *
     * @throws \Propel\Runtime\Exception\PropelException
     * @see doSave()
     */
    protected function doInsert(ConnectionInterface $con): void
    {
        $modifiedColumns = [];
        $index = 0;

        $this->modifiedColumns[UserTableMap::COL_ID] = true;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . UserTableMap::COL_ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(UserTableMap::COL_ID)) {
            $modifiedColumns[':p' . $index++]  = '`id`';
        }
        if ($this->isColumnModified(UserTableMap::COL_NAME)) {
            $modifiedColumns[':p' . $index++]  = '`name`';
        }
        if ($this->isColumnModified(UserTableMap::COL_EMAIL)) {
            $modifiedColumns[':p' . $index++]  = '`email`';
        }
        if ($this->isColumnModified(UserTableMap::COL_PASSWORD)) {
            $modifiedColumns[':p' . $index++]  = '`password`';
        }
        if ($this->isColumnModified(UserTableMap::COL_ACTIVATION)) {
            $modifiedColumns[':p' . $index++]  = '`activation`';
        }
        if ($this->isColumnModified(UserTableMap::COL_GROUP_ID)) {
            $modifiedColumns[':p' . $index++]  = '`group_id`';
        }
        if ($this->isColumnModified(UserTableMap::COL_USR_DELETE)) {
            $modifiedColumns[':p' . $index++]  = '`usr_delete`';
        }
        if ($this->isColumnModified(UserTableMap::COL_CREATED_AT)) {
            $modifiedColumns[':p' . $index++]  = '`created_at`';
        }
        if ($this->isColumnModified(UserTableMap::COL_PHONE)) {
            $modifiedColumns[':p' . $index++]  = '`phone`';
        }

        $sql = sprintf(
            'INSERT INTO `_users` (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case '`id`':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case '`name`':
                        $stmt->bindValue($identifier, $this->name, PDO::PARAM_STR);
                        break;
                    case '`email`':
                        $stmt->bindValue($identifier, $this->email, PDO::PARAM_STR);
                        break;
                    case '`password`':
                        $stmt->bindValue($identifier, $this->password, PDO::PARAM_STR);
                        break;
                    case '`activation`':
                        $stmt->bindValue($identifier, $this->activation, PDO::PARAM_STR);
                        break;
                    case '`group_id`':
                        $stmt->bindValue($identifier, $this->group_id, PDO::PARAM_INT);
                        break;
                    case '`usr_delete`':
                        $stmt->bindValue($identifier, $this->usr_delete, PDO::PARAM_INT);
                        break;
                    case '`created_at`':
                        $stmt->bindValue($identifier, $this->created_at ? $this->created_at->format("Y-m-d H:i:s.u") : null, PDO::PARAM_STR);
                        break;
                    case '`phone`':
                        $stmt->bindValue($identifier, $this->phone, PDO::PARAM_STR);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), 0, $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', 0, $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param ConnectionInterface $con
     *
     * @return int Number of updated rows
     * @see doSave()
     */
    protected function doUpdate(ConnectionInterface $con): int
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();

        return $selectCriteria->doUpdate($valuesCriteria, $con);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param string $name name
     * @param string $type The type of fieldname the $name is of:
     *                     one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                     TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                     Defaults to TableMap::TYPE_PHPNAME.
     * @return mixed Value of field.
     */
    public function getByName(string $name, string $type = TableMap::TYPE_PHPNAME)
    {
        $pos = UserTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos Position in XML schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition(int $pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();

            case 1:
                return $this->getName();

            case 2:
                return $this->getEmail();

            case 3:
                return $this->getPassword();

            case 4:
                return $this->getActivation();

            case 5:
                return $this->getGroupId();

            case 6:
                return $this->getUsrDelete();

            case 7:
                return $this->getCreatedAt();

            case 8:
                return $this->getPhone();

            default:
                return null;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param string $keyType (optional) One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     *                    TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                    Defaults to TableMap::TYPE_PHPNAME.
     * @param bool $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to TRUE.
     * @param array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param bool $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array An associative array containing the field names (as keys) and field values
     */
    public function toArray(string $keyType = TableMap::TYPE_PHPNAME, bool $includeLazyLoadColumns = true, array $alreadyDumpedObjects = [], bool $includeForeignObjects = false): array
    {
        if (isset($alreadyDumpedObjects['User'][$this->hashCode()])) {
            return ['*RECURSION*'];
        }
        $alreadyDumpedObjects['User'][$this->hashCode()] = true;
        $keys = UserTableMap::getFieldNames($keyType);
        $result = [
            $keys[0] => $this->getId(),
            $keys[1] => $this->getName(),
            $keys[2] => $this->getEmail(),
            $keys[3] => $this->getPassword(),
            $keys[4] => $this->getActivation(),
            $keys[5] => $this->getGroupId(),
            $keys[6] => $this->getUsrDelete(),
            $keys[7] => $this->getCreatedAt(),
            $keys[8] => $this->getPhone(),
        ];
        if ($result[$keys[7]] instanceof \DateTimeInterface) {
            $result[$keys[7]] = $result[$keys[7]]->format('Y-m-d H:i:s.u');
        }

        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->aUserGroup) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'userGroup';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = '_user_groups';
                        break;
                    default:
                        $key = 'UserGroup';
                }

                $result[$key] = $this->aUserGroup->toArray($keyType, $includeLazyLoadColumns,  $alreadyDumpedObjects, true);
            }
            if (null !== $this->collClientsUsersRels) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'clientsUsersRels';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'partscanner_clients_users_rels';
                        break;
                    default:
                        $key = 'ClientsUsersRels';
                }

                $result[$key] = $this->collClientsUsersRels->toArray(null, false, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collChats) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'chats';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'partscanner_chatss';
                        break;
                    default:
                        $key = 'Chats';
                }

                $result[$key] = $this->collChats->toArray(null, false, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collChatMessages) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'chatMessages';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'partscanner_chat_messagess';
                        break;
                    default:
                        $key = 'ChatMessages';
                }

                $result[$key] = $this->collChatMessages->toArray(null, false, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param string $name
     * @param mixed $value field value
     * @param string $type The type of fieldname the $name is of:
     *                one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                Defaults to TableMap::TYPE_PHPNAME.
     * @return $this
     */
    public function setByName(string $name, $value, string $type = TableMap::TYPE_PHPNAME)
    {
        $pos = UserTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);

        $this->setByPosition($pos, $value);

        return $this;
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @param mixed $value field value
     * @return $this
     */
    public function setByPosition(int $pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setName($value);
                break;
            case 2:
                $this->setEmail($value);
                break;
            case 3:
                $this->setPassword($value);
                break;
            case 4:
                $this->setActivation($value);
                break;
            case 5:
                $this->setGroupId($value);
                break;
            case 6:
                $this->setUsrDelete($value);
                break;
            case 7:
                $this->setCreatedAt($value);
                break;
            case 8:
                $this->setPhone($value);
                break;
        } // switch()

        return $this;
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     * TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     * The default key type is the column's TableMap::TYPE_PHPNAME.
     *
     * @param array $arr An array to populate the object from.
     * @param string $keyType The type of keys the array uses.
     * @return $this
     */
    public function fromArray(array $arr, string $keyType = TableMap::TYPE_PHPNAME)
    {
        $keys = UserTableMap::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) {
            $this->setId($arr[$keys[0]]);
        }
        if (array_key_exists($keys[1], $arr)) {
            $this->setName($arr[$keys[1]]);
        }
        if (array_key_exists($keys[2], $arr)) {
            $this->setEmail($arr[$keys[2]]);
        }
        if (array_key_exists($keys[3], $arr)) {
            $this->setPassword($arr[$keys[3]]);
        }
        if (array_key_exists($keys[4], $arr)) {
            $this->setActivation($arr[$keys[4]]);
        }
        if (array_key_exists($keys[5], $arr)) {
            $this->setGroupId($arr[$keys[5]]);
        }
        if (array_key_exists($keys[6], $arr)) {
            $this->setUsrDelete($arr[$keys[6]]);
        }
        if (array_key_exists($keys[7], $arr)) {
            $this->setCreatedAt($arr[$keys[7]]);
        }
        if (array_key_exists($keys[8], $arr)) {
            $this->setPhone($arr[$keys[8]]);
        }

        return $this;
    }

     /**
     * Populate the current object from a string, using a given parser format
     * <code>
     * $book = new Book();
     * $book->importFrom('JSON', '{"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     * TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     * The default key type is the column's TableMap::TYPE_PHPNAME.
     *
     * @param mixed $parser A AbstractParser instance,
     *                       or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param string $data The source data to import from
     * @param string $keyType The type of keys the array uses.
     *
     * @return $this The current object, for fluid interface
     */
    public function importFrom($parser, string $data, string $keyType = TableMap::TYPE_PHPNAME)
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        $this->fromArray($parser->toArray($data), $keyType);

        return $this;
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return \Propel\Runtime\ActiveQuery\Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria(): Criteria
    {
        $criteria = new Criteria(UserTableMap::DATABASE_NAME);

        if ($this->isColumnModified(UserTableMap::COL_ID)) {
            $criteria->add(UserTableMap::COL_ID, $this->id);
        }
        if ($this->isColumnModified(UserTableMap::COL_NAME)) {
            $criteria->add(UserTableMap::COL_NAME, $this->name);
        }
        if ($this->isColumnModified(UserTableMap::COL_EMAIL)) {
            $criteria->add(UserTableMap::COL_EMAIL, $this->email);
        }
        if ($this->isColumnModified(UserTableMap::COL_PASSWORD)) {
            $criteria->add(UserTableMap::COL_PASSWORD, $this->password);
        }
        if ($this->isColumnModified(UserTableMap::COL_ACTIVATION)) {
            $criteria->add(UserTableMap::COL_ACTIVATION, $this->activation);
        }
        if ($this->isColumnModified(UserTableMap::COL_GROUP_ID)) {
            $criteria->add(UserTableMap::COL_GROUP_ID, $this->group_id);
        }
        if ($this->isColumnModified(UserTableMap::COL_USR_DELETE)) {
            $criteria->add(UserTableMap::COL_USR_DELETE, $this->usr_delete);
        }
        if ($this->isColumnModified(UserTableMap::COL_CREATED_AT)) {
            $criteria->add(UserTableMap::COL_CREATED_AT, $this->created_at);
        }
        if ($this->isColumnModified(UserTableMap::COL_PHONE)) {
            $criteria->add(UserTableMap::COL_PHONE, $this->phone);
        }

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether they have been modified.
     *
     * @throws LogicException if no primary key is defined
     *
     * @return \Propel\Runtime\ActiveQuery\Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria(): Criteria
    {
        $criteria = ChildUserQuery::create();
        $criteria->add(UserTableMap::COL_ID, $this->id);

        return $criteria;
    }

    /**
     * If the primary key is not null, return the hashcode of the
     * primary key. Otherwise, return the hash code of the object.
     *
     * @return int|string Hashcode
     */
    public function hashCode()
    {
        $validPk = null !== $this->getId();

        $validPrimaryKeyFKs = 0;
        $primaryKeyFKs = [];

        if ($validPk) {
            return crc32(json_encode($this->getPrimaryKey(), JSON_UNESCAPED_UNICODE));
        } elseif ($validPrimaryKeyFKs) {
            return crc32(json_encode($primaryKeyFKs, JSON_UNESCAPED_UNICODE));
        }

        return spl_object_hash($this);
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param int|null $key Primary key.
     * @return void
     */
    public function setPrimaryKey(?int $key = null): void
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     *
     * @return bool
     */
    public function isPrimaryKeyNull(): bool
    {
        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param object $copyObj An object of \Diamond\Infrastructure\Models\User\User (or compatible) type.
     * @param bool $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param bool $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws \Propel\Runtime\Exception\PropelException
     * @return void
     */
    public function copyInto(object $copyObj, bool $deepCopy = false, bool $makeNew = true): void
    {
        $copyObj->setName($this->getName());
        $copyObj->setEmail($this->getEmail());
        $copyObj->setPassword($this->getPassword());
        $copyObj->setActivation($this->getActivation());
        $copyObj->setGroupId($this->getGroupId());
        $copyObj->setUsrDelete($this->getUsrDelete());
        $copyObj->setCreatedAt($this->getCreatedAt());
        $copyObj->setPhone($this->getPhone());

        if ($deepCopy) {
            // important: temporarily setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);

            foreach ($this->getClientsUsersRels() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addClientsUsersRel($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getChats() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addChat($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getChatMessages() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addChatMessage($relObj->copy($deepCopy));
                }
            }

        } // if ($deepCopy)

        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param bool $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return \Diamond\Infrastructure\Models\User\User Clone of current object.
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function copy(bool $deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Declares an association between this object and a UserGroup object.
     *
     * @param UserGroup $v
     * @return $this The current object (for fluent API support)
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function setUserGroup(UserGroup $v = null)
    {
        if ($v === null) {
            $this->setGroupId(NULL);
        } else {
            $this->setGroupId($v->getId());
        }

        $this->aUserGroup = $v;

        // Add binding for other direction of this n:n relationship.
        // If this object has already been added to the UserGroup object, it will not be re-added.
        if ($v !== null) {
            $v->addUser($this);
        }


        return $this;
    }


    /**
     * Get the associated UserGroup object
     *
     * @param ConnectionInterface $con Optional Connection object.
     * @return UserGroup The associated UserGroup object.
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function getUserGroup(?ConnectionInterface $con = null)
    {
        if ($this->aUserGroup === null && ($this->group_id != 0)) {
            $this->aUserGroup = UserGroupQuery::create()->findPk($this->group_id, $con);
            /* The following can be used additionally to
                guarantee the related object contains a reference
                to this object.  This level of coupling may, however, be
                undesirable since it could result in an only partially populated collection
                in the referenced object.
                $this->aUserGroup->addUsers($this);
             */
        }

        return $this->aUserGroup;
    }


    /**
     * Initializes a collection based on the name of a relation.
     * Avoids crafting an 'init[$relationName]s' method name
     * that wouldn't work when StandardEnglishPluralizer is used.
     *
     * @param string $relationName The name of the relation to initialize
     * @return void
     */
    public function initRelation($relationName): void
    {
        if ('ClientsUsersRel' === $relationName) {
            $this->initClientsUsersRels();
            return;
        }
        if ('Chat' === $relationName) {
            $this->initChats();
            return;
        }
        if ('ChatMessage' === $relationName) {
            $this->initChatMessages();
            return;
        }
    }

    /**
     * Clears out the collClientsUsersRels collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return $this
     * @see addClientsUsersRels()
     */
    public function clearClientsUsersRels()
    {
        $this->collClientsUsersRels = null; // important to set this to NULL since that means it is uninitialized

        return $this;
    }

    /**
     * Reset is the collClientsUsersRels collection loaded partially.
     *
     * @return void
     */
    public function resetPartialClientsUsersRels($v = true): void
    {
        $this->collClientsUsersRelsPartial = $v;
    }

    /**
     * Initializes the collClientsUsersRels collection.
     *
     * By default this just sets the collClientsUsersRels collection to an empty array (like clearcollClientsUsersRels());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param bool $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initClientsUsersRels(bool $overrideExisting = true): void
    {
        if (null !== $this->collClientsUsersRels && !$overrideExisting) {
            return;
        }

        $collectionClassName = ClientsUsersRelTableMap::getTableMap()->getCollectionClassName();

        $this->collClientsUsersRels = new $collectionClassName;
        $this->collClientsUsersRels->setModel('\PartScanner\Infrastructure\Models\ClientsUsersRel\ClientsUsersRel');
    }

    /**
     * Gets an array of ClientsUsersRel objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this ChildUser is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @return ObjectCollection|ClientsUsersRel[] List of ClientsUsersRel objects
     * @phpstan-return ObjectCollection&\Traversable<ClientsUsersRel> List of ClientsUsersRel objects
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function getClientsUsersRels(?Criteria $criteria = null, ?ConnectionInterface $con = null)
    {
        $partial = $this->collClientsUsersRelsPartial && !$this->isNew();
        if (null === $this->collClientsUsersRels || null !== $criteria || $partial) {
            if ($this->isNew()) {
                // return empty collection
                if (null === $this->collClientsUsersRels) {
                    $this->initClientsUsersRels();
                } else {
                    $collectionClassName = ClientsUsersRelTableMap::getTableMap()->getCollectionClassName();

                    $collClientsUsersRels = new $collectionClassName;
                    $collClientsUsersRels->setModel('\PartScanner\Infrastructure\Models\ClientsUsersRel\ClientsUsersRel');

                    return $collClientsUsersRels;
                }
            } else {
                $collClientsUsersRels = ClientsUsersRelQuery::create(null, $criteria)
                    ->filterByUser($this)
                    ->find($con);

                if (null !== $criteria) {
                    if (false !== $this->collClientsUsersRelsPartial && count($collClientsUsersRels)) {
                        $this->initClientsUsersRels(false);

                        foreach ($collClientsUsersRels as $obj) {
                            if (false == $this->collClientsUsersRels->contains($obj)) {
                                $this->collClientsUsersRels->append($obj);
                            }
                        }

                        $this->collClientsUsersRelsPartial = true;
                    }

                    return $collClientsUsersRels;
                }

                if ($partial && $this->collClientsUsersRels) {
                    foreach ($this->collClientsUsersRels as $obj) {
                        if ($obj->isNew()) {
                            $collClientsUsersRels[] = $obj;
                        }
                    }
                }

                $this->collClientsUsersRels = $collClientsUsersRels;
                $this->collClientsUsersRelsPartial = false;
            }
        }

        return $this->collClientsUsersRels;
    }

    /**
     * Sets a collection of ClientsUsersRel objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param Collection $clientsUsersRels A Propel collection.
     * @param ConnectionInterface $con Optional connection object
     * @return $this The current object (for fluent API support)
     */
    public function setClientsUsersRels(Collection $clientsUsersRels, ?ConnectionInterface $con = null)
    {
        /** @var ClientsUsersRel[] $clientsUsersRelsToDelete */
        $clientsUsersRelsToDelete = $this->getClientsUsersRels(new Criteria(), $con)->diff($clientsUsersRels);


        //since at least one column in the foreign key is at the same time a PK
        //we can not just set a PK to NULL in the lines below. We have to store
        //a backup of all values, so we are able to manipulate these items based on the onDelete value later.
        $this->clientsUsersRelsScheduledForDeletion = clone $clientsUsersRelsToDelete;

        foreach ($clientsUsersRelsToDelete as $clientsUsersRelRemoved) {
            $clientsUsersRelRemoved->setUser(null);
        }

        $this->collClientsUsersRels = null;
        foreach ($clientsUsersRels as $clientsUsersRel) {
            $this->addClientsUsersRel($clientsUsersRel);
        }

        $this->collClientsUsersRels = $clientsUsersRels;
        $this->collClientsUsersRelsPartial = false;

        return $this;
    }

    /**
     * Returns the number of related BaseClientsUsersRel objects.
     *
     * @param Criteria $criteria
     * @param bool $distinct
     * @param ConnectionInterface $con
     * @return int Count of related BaseClientsUsersRel objects.
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function countClientsUsersRels(?Criteria $criteria = null, bool $distinct = false, ?ConnectionInterface $con = null): int
    {
        $partial = $this->collClientsUsersRelsPartial && !$this->isNew();
        if (null === $this->collClientsUsersRels || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collClientsUsersRels) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getClientsUsersRels());
            }

            $query = ClientsUsersRelQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByUser($this)
                ->count($con);
        }

        return count($this->collClientsUsersRels);
    }

    /**
     * Method called to associate a ClientsUsersRel object to this object
     * through the ClientsUsersRel foreign key attribute.
     *
     * @param ClientsUsersRel $l ClientsUsersRel
     * @return $this The current object (for fluent API support)
     */
    public function addClientsUsersRel(ClientsUsersRel $l)
    {
        if ($this->collClientsUsersRels === null) {
            $this->initClientsUsersRels();
            $this->collClientsUsersRelsPartial = true;
        }

        if (!$this->collClientsUsersRels->contains($l)) {
            $this->doAddClientsUsersRel($l);

            if ($this->clientsUsersRelsScheduledForDeletion and $this->clientsUsersRelsScheduledForDeletion->contains($l)) {
                $this->clientsUsersRelsScheduledForDeletion->remove($this->clientsUsersRelsScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param ClientsUsersRel $clientsUsersRel The ClientsUsersRel object to add.
     */
    protected function doAddClientsUsersRel(ClientsUsersRel $clientsUsersRel): void
    {
        $this->collClientsUsersRels[]= $clientsUsersRel;
        $clientsUsersRel->setUser($this);
    }

    /**
     * @param ClientsUsersRel $clientsUsersRel The ClientsUsersRel object to remove.
     * @return $this The current object (for fluent API support)
     */
    public function removeClientsUsersRel(ClientsUsersRel $clientsUsersRel)
    {
        if ($this->getClientsUsersRels()->contains($clientsUsersRel)) {
            $pos = $this->collClientsUsersRels->search($clientsUsersRel);
            $this->collClientsUsersRels->remove($pos);
            if (null === $this->clientsUsersRelsScheduledForDeletion) {
                $this->clientsUsersRelsScheduledForDeletion = clone $this->collClientsUsersRels;
                $this->clientsUsersRelsScheduledForDeletion->clear();
            }
            $this->clientsUsersRelsScheduledForDeletion[]= clone $clientsUsersRel;
            $clientsUsersRel->setUser(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this User is new, it will return
     * an empty collection; or if this User has previously
     * been saved, it will retrieve related ClientsUsersRels from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in User.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @param string $joinBehavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return ObjectCollection|ClientsUsersRel[] List of ClientsUsersRel objects
     * @phpstan-return ObjectCollection&\Traversable<ClientsUsersRel}> List of ClientsUsersRel objects
     */
    public function getClientsUsersRelsJoinClient(?Criteria $criteria = null, ?ConnectionInterface $con = null, $joinBehavior = Criteria::LEFT_JOIN)
    {
        $query = ClientsUsersRelQuery::create(null, $criteria);
        $query->joinWith('Client', $joinBehavior);

        return $this->getClientsUsersRels($query, $con);
    }

    /**
     * Clears out the collChats collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return $this
     * @see addChats()
     */
    public function clearChats()
    {
        $this->collChats = null; // important to set this to NULL since that means it is uninitialized

        return $this;
    }

    /**
     * Reset is the collChats collection loaded partially.
     *
     * @return void
     */
    public function resetPartialChats($v = true): void
    {
        $this->collChatsPartial = $v;
    }

    /**
     * Initializes the collChats collection.
     *
     * By default this just sets the collChats collection to an empty array (like clearcollChats());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param bool $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initChats(bool $overrideExisting = true): void
    {
        if (null !== $this->collChats && !$overrideExisting) {
            return;
        }

        $collectionClassName = ChatTableMap::getTableMap()->getCollectionClassName();

        $this->collChats = new $collectionClassName;
        $this->collChats->setModel('\PartScanner\Infrastructure\Models\Chat\Chat');
    }

    /**
     * Gets an array of Chat objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this ChildUser is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @return ObjectCollection|Chat[] List of Chat objects
     * @phpstan-return ObjectCollection&\Traversable<Chat> List of Chat objects
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function getChats(?Criteria $criteria = null, ?ConnectionInterface $con = null)
    {
        $partial = $this->collChatsPartial && !$this->isNew();
        if (null === $this->collChats || null !== $criteria || $partial) {
            if ($this->isNew()) {
                // return empty collection
                if (null === $this->collChats) {
                    $this->initChats();
                } else {
                    $collectionClassName = ChatTableMap::getTableMap()->getCollectionClassName();

                    $collChats = new $collectionClassName;
                    $collChats->setModel('\PartScanner\Infrastructure\Models\Chat\Chat');

                    return $collChats;
                }
            } else {
                $collChats = ChatQuery::create(null, $criteria)
                    ->filterByAuthor($this)
                    ->find($con);

                if (null !== $criteria) {
                    if (false !== $this->collChatsPartial && count($collChats)) {
                        $this->initChats(false);

                        foreach ($collChats as $obj) {
                            if (false == $this->collChats->contains($obj)) {
                                $this->collChats->append($obj);
                            }
                        }

                        $this->collChatsPartial = true;
                    }

                    return $collChats;
                }

                if ($partial && $this->collChats) {
                    foreach ($this->collChats as $obj) {
                        if ($obj->isNew()) {
                            $collChats[] = $obj;
                        }
                    }
                }

                $this->collChats = $collChats;
                $this->collChatsPartial = false;
            }
        }

        return $this->collChats;
    }

    /**
     * Sets a collection of Chat objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param Collection $chats A Propel collection.
     * @param ConnectionInterface $con Optional connection object
     * @return $this The current object (for fluent API support)
     */
    public function setChats(Collection $chats, ?ConnectionInterface $con = null)
    {
        /** @var Chat[] $chatsToDelete */
        $chatsToDelete = $this->getChats(new Criteria(), $con)->diff($chats);


        $this->chatsScheduledForDeletion = $chatsToDelete;

        foreach ($chatsToDelete as $chatRemoved) {
            $chatRemoved->setAuthor(null);
        }

        $this->collChats = null;
        foreach ($chats as $chat) {
            $this->addChat($chat);
        }

        $this->collChats = $chats;
        $this->collChatsPartial = false;

        return $this;
    }

    /**
     * Returns the number of related BaseChat objects.
     *
     * @param Criteria $criteria
     * @param bool $distinct
     * @param ConnectionInterface $con
     * @return int Count of related BaseChat objects.
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function countChats(?Criteria $criteria = null, bool $distinct = false, ?ConnectionInterface $con = null): int
    {
        $partial = $this->collChatsPartial && !$this->isNew();
        if (null === $this->collChats || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collChats) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getChats());
            }

            $query = ChatQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByAuthor($this)
                ->count($con);
        }

        return count($this->collChats);
    }

    /**
     * Method called to associate a Chat object to this object
     * through the Chat foreign key attribute.
     *
     * @param Chat $l Chat
     * @return $this The current object (for fluent API support)
     */
    public function addChat(Chat $l)
    {
        if ($this->collChats === null) {
            $this->initChats();
            $this->collChatsPartial = true;
        }

        if (!$this->collChats->contains($l)) {
            $this->doAddChat($l);

            if ($this->chatsScheduledForDeletion and $this->chatsScheduledForDeletion->contains($l)) {
                $this->chatsScheduledForDeletion->remove($this->chatsScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param Chat $chat The Chat object to add.
     */
    protected function doAddChat(Chat $chat): void
    {
        $this->collChats[]= $chat;
        $chat->setAuthor($this);
    }

    /**
     * @param Chat $chat The Chat object to remove.
     * @return $this The current object (for fluent API support)
     */
    public function removeChat(Chat $chat)
    {
        if ($this->getChats()->contains($chat)) {
            $pos = $this->collChats->search($chat);
            $this->collChats->remove($pos);
            if (null === $this->chatsScheduledForDeletion) {
                $this->chatsScheduledForDeletion = clone $this->collChats;
                $this->chatsScheduledForDeletion->clear();
            }
            $this->chatsScheduledForDeletion[]= clone $chat;
            $chat->setAuthor(null);
        }

        return $this;
    }

    /**
     * Clears out the collChatMessages collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return $this
     * @see addChatMessages()
     */
    public function clearChatMessages()
    {
        $this->collChatMessages = null; // important to set this to NULL since that means it is uninitialized

        return $this;
    }

    /**
     * Reset is the collChatMessages collection loaded partially.
     *
     * @return void
     */
    public function resetPartialChatMessages($v = true): void
    {
        $this->collChatMessagesPartial = $v;
    }

    /**
     * Initializes the collChatMessages collection.
     *
     * By default this just sets the collChatMessages collection to an empty array (like clearcollChatMessages());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param bool $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initChatMessages(bool $overrideExisting = true): void
    {
        if (null !== $this->collChatMessages && !$overrideExisting) {
            return;
        }

        $collectionClassName = ChatMessageTableMap::getTableMap()->getCollectionClassName();

        $this->collChatMessages = new $collectionClassName;
        $this->collChatMessages->setModel('\PartScanner\Infrastructure\Models\ChatMessage\ChatMessage');
    }

    /**
     * Gets an array of ChatMessage objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this ChildUser is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @return ObjectCollection|ChatMessage[] List of ChatMessage objects
     * @phpstan-return ObjectCollection&\Traversable<ChatMessage> List of ChatMessage objects
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function getChatMessages(?Criteria $criteria = null, ?ConnectionInterface $con = null)
    {
        $partial = $this->collChatMessagesPartial && !$this->isNew();
        if (null === $this->collChatMessages || null !== $criteria || $partial) {
            if ($this->isNew()) {
                // return empty collection
                if (null === $this->collChatMessages) {
                    $this->initChatMessages();
                } else {
                    $collectionClassName = ChatMessageTableMap::getTableMap()->getCollectionClassName();

                    $collChatMessages = new $collectionClassName;
                    $collChatMessages->setModel('\PartScanner\Infrastructure\Models\ChatMessage\ChatMessage');

                    return $collChatMessages;
                }
            } else {
                $collChatMessages = ChatMessageQuery::create(null, $criteria)
                    ->filterByUser($this)
                    ->find($con);

                if (null !== $criteria) {
                    if (false !== $this->collChatMessagesPartial && count($collChatMessages)) {
                        $this->initChatMessages(false);

                        foreach ($collChatMessages as $obj) {
                            if (false == $this->collChatMessages->contains($obj)) {
                                $this->collChatMessages->append($obj);
                            }
                        }

                        $this->collChatMessagesPartial = true;
                    }

                    return $collChatMessages;
                }

                if ($partial && $this->collChatMessages) {
                    foreach ($this->collChatMessages as $obj) {
                        if ($obj->isNew()) {
                            $collChatMessages[] = $obj;
                        }
                    }
                }

                $this->collChatMessages = $collChatMessages;
                $this->collChatMessagesPartial = false;
            }
        }

        return $this->collChatMessages;
    }

    /**
     * Sets a collection of ChatMessage objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param Collection $chatMessages A Propel collection.
     * @param ConnectionInterface $con Optional connection object
     * @return $this The current object (for fluent API support)
     */
    public function setChatMessages(Collection $chatMessages, ?ConnectionInterface $con = null)
    {
        /** @var ChatMessage[] $chatMessagesToDelete */
        $chatMessagesToDelete = $this->getChatMessages(new Criteria(), $con)->diff($chatMessages);


        $this->chatMessagesScheduledForDeletion = $chatMessagesToDelete;

        foreach ($chatMessagesToDelete as $chatMessageRemoved) {
            $chatMessageRemoved->setUser(null);
        }

        $this->collChatMessages = null;
        foreach ($chatMessages as $chatMessage) {
            $this->addChatMessage($chatMessage);
        }

        $this->collChatMessages = $chatMessages;
        $this->collChatMessagesPartial = false;

        return $this;
    }

    /**
     * Returns the number of related BaseChatMessage objects.
     *
     * @param Criteria $criteria
     * @param bool $distinct
     * @param ConnectionInterface $con
     * @return int Count of related BaseChatMessage objects.
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function countChatMessages(?Criteria $criteria = null, bool $distinct = false, ?ConnectionInterface $con = null): int
    {
        $partial = $this->collChatMessagesPartial && !$this->isNew();
        if (null === $this->collChatMessages || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collChatMessages) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getChatMessages());
            }

            $query = ChatMessageQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByUser($this)
                ->count($con);
        }

        return count($this->collChatMessages);
    }

    /**
     * Method called to associate a ChatMessage object to this object
     * through the ChatMessage foreign key attribute.
     *
     * @param ChatMessage $l ChatMessage
     * @return $this The current object (for fluent API support)
     */
    public function addChatMessage(ChatMessage $l)
    {
        if ($this->collChatMessages === null) {
            $this->initChatMessages();
            $this->collChatMessagesPartial = true;
        }

        if (!$this->collChatMessages->contains($l)) {
            $this->doAddChatMessage($l);

            if ($this->chatMessagesScheduledForDeletion and $this->chatMessagesScheduledForDeletion->contains($l)) {
                $this->chatMessagesScheduledForDeletion->remove($this->chatMessagesScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param ChatMessage $chatMessage The ChatMessage object to add.
     */
    protected function doAddChatMessage(ChatMessage $chatMessage): void
    {
        $this->collChatMessages[]= $chatMessage;
        $chatMessage->setUser($this);
    }

    /**
     * @param ChatMessage $chatMessage The ChatMessage object to remove.
     * @return $this The current object (for fluent API support)
     */
    public function removeChatMessage(ChatMessage $chatMessage)
    {
        if ($this->getChatMessages()->contains($chatMessage)) {
            $pos = $this->collChatMessages->search($chatMessage);
            $this->collChatMessages->remove($pos);
            if (null === $this->chatMessagesScheduledForDeletion) {
                $this->chatMessagesScheduledForDeletion = clone $this->collChatMessages;
                $this->chatMessagesScheduledForDeletion->clear();
            }
            $this->chatMessagesScheduledForDeletion[]= $chatMessage;
            $chatMessage->setUser(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this User is new, it will return
     * an empty collection; or if this User has previously
     * been saved, it will retrieve related ChatMessages from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in User.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param ConnectionInterface $con optional connection object
     * @param string $joinBehavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return ObjectCollection|ChatMessage[] List of ChatMessage objects
     * @phpstan-return ObjectCollection&\Traversable<ChatMessage}> List of ChatMessage objects
     */
    public function getChatMessagesJoinChat(?Criteria $criteria = null, ?ConnectionInterface $con = null, $joinBehavior = Criteria::LEFT_JOIN)
    {
        $query = ChatMessageQuery::create(null, $criteria);
        $query->joinWith('Chat', $joinBehavior);

        return $this->getChatMessages($query, $con);
    }

    /**
     * Clears out the collClients collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return void
     * @see        addClients()
     */
    public function clearClients()
    {
        $this->collClients = null; // important to set this to NULL since that means it is uninitialized
    }

    /**
     * Initializes the collClients crossRef collection.
     *
     * By default this just sets the collClients collection to an empty collection (like clearClients());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @return void
     */
    public function initClients()
    {
        $collectionClassName = ClientsUsersRelTableMap::getTableMap()->getCollectionClassName();

        $this->collClients = new $collectionClassName;
        $this->collClientsPartial = true;
        $this->collClients->setModel('\PartScanner\Infrastructure\Models\Client\Client');
    }

    /**
     * Checks if the collClients collection is loaded.
     *
     * @return bool
     */
    public function isClientsLoaded(): bool
    {
        return null !== $this->collClients;
    }

    /**
     * Gets a collection of Client objects related by a many-to-many relationship
     * to the current object by way of the partscanner_clients_users_rel cross-reference table.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this ChildUser is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria Optional query object to filter the query
     * @param ConnectionInterface $con Optional connection object
     *
     * @return ObjectCollection|Client[] List of Client objects
     * @phpstan-return ObjectCollection&\Traversable<Client> List of Client objects
     */
    public function getClients(?Criteria $criteria = null, ?ConnectionInterface $con = null)
    {
        $partial = $this->collClientsPartial && !$this->isNew();
        if (null === $this->collClients || null !== $criteria || $partial) {
            if ($this->isNew()) {
                // return empty collection
                if (null === $this->collClients) {
                    $this->initClients();
                }
            } else {

                $query = ClientQuery::create(null, $criteria)
                    ->filterByUser($this);
                $collClients = $query->find($con);
                if (null !== $criteria) {
                    return $collClients;
                }

                if ($partial && $this->collClients) {
                    //make sure that already added objects gets added to the list of the database.
                    foreach ($this->collClients as $obj) {
                        if (!$collClients->contains($obj)) {
                            $collClients[] = $obj;
                        }
                    }
                }

                $this->collClients = $collClients;
                $this->collClientsPartial = false;
            }
        }

        return $this->collClients;
    }

    /**
     * Sets a collection of Client objects related by a many-to-many relationship
     * to the current object by way of the partscanner_clients_users_rel cross-reference table.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param Collection $clients A Propel collection.
     * @param ConnectionInterface $con Optional connection object
     * @return $this The current object (for fluent API support)
     */
    public function setClients(Collection $clients, ?ConnectionInterface $con = null)
    {
        $this->clearClients();
        $currentClients = $this->getClients();

        $clientsScheduledForDeletion = $currentClients->diff($clients);

        foreach ($clientsScheduledForDeletion as $toDelete) {
            $this->removeClient($toDelete);
        }

        foreach ($clients as $client) {
            if (!$currentClients->contains($client)) {
                $this->doAddClient($client);
            }
        }

        $this->collClientsPartial = false;
        $this->collClients = $clients;

        return $this;
    }

    /**
     * Gets the number of Client objects related by a many-to-many relationship
     * to the current object by way of the partscanner_clients_users_rel cross-reference table.
     *
     * @param Criteria $criteria Optional query object to filter the query
     * @param bool $distinct Set to true to force count distinct
     * @param ConnectionInterface $con Optional connection object
     *
     * @return int The number of related Client objects
     */
    public function countClients(?Criteria $criteria = null, $distinct = false, ?ConnectionInterface $con = null): int
    {
        $partial = $this->collClientsPartial && !$this->isNew();
        if (null === $this->collClients || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collClients) {
                return 0;
            } else {

                if ($partial && !$criteria) {
                    return count($this->getClients());
                }

                $query = ClientQuery::create(null, $criteria);
                if ($distinct) {
                    $query->distinct();
                }

                return $query
                    ->filterByUser($this)
                    ->count($con);
            }
        } else {
            return count($this->collClients);
        }
    }

    /**
     * Associate a Client to this object
     * through the partscanner_clients_users_rel cross reference table.
     *
     * @param Client $client
     * @return ChildUser The current object (for fluent API support)
     */
    public function addClient(Client $client)
    {
        if ($this->collClients === null) {
            $this->initClients();
        }

        if (!$this->getClients()->contains($client)) {
            // only add it if the **same** object is not already associated
            $this->collClients->push($client);
            $this->doAddClient($client);
        }

        return $this;
    }

    /**
     *
     * @param Client $client
     */
    protected function doAddClient(Client $client)
    {
        $clientsUsersRel = new ClientsUsersRel();

        $clientsUsersRel->setClient($client);

        $clientsUsersRel->setUser($this);

        $this->addClientsUsersRel($clientsUsersRel);

        // set the back reference to this object directly as using provided method either results
        // in endless loop or in multiple relations
        if (!$client->isUsersLoaded()) {
            $client->initUsers();
            $client->getUsers()->push($this);
        } elseif (!$client->getUsers()->contains($this)) {
            $client->getUsers()->push($this);
        }

    }

    /**
     * Remove client of this object
     * through the partscanner_clients_users_rel cross reference table.
     *
     * @param Client $client
     * @return ChildUser The current object (for fluent API support)
     */
    public function removeClient(Client $client)
    {
        if ($this->getClients()->contains($client)) {
            $clientsUsersRel = new ClientsUsersRel();
            $clientsUsersRel->setClient($client);
            if ($client->isUsersLoaded()) {
                //remove the back reference if available
                $client->getUsers()->removeObject($this);
            }

            $clientsUsersRel->setUser($this);
            $this->removeClientsUsersRel(clone $clientsUsersRel);
            $clientsUsersRel->clear();

            $this->collClients->remove($this->collClients->search($client));

            if (null === $this->clientsScheduledForDeletion) {
                $this->clientsScheduledForDeletion = clone $this->collClients;
                $this->clientsScheduledForDeletion->clear();
            }

            $this->clientsScheduledForDeletion->push($client);
        }


        return $this;
    }

    /**
     * Clears the current object, sets all attributes to their default values and removes
     * outgoing references as well as back-references (from other objects to this one. Results probably in a database
     * change of those foreign objects when you call `save` there).
     *
     * @return $this
     */
    public function clear()
    {
        if (null !== $this->aUserGroup) {
            $this->aUserGroup->removeUser($this);
        }
        $this->id = null;
        $this->name = null;
        $this->email = null;
        $this->password = null;
        $this->activation = null;
        $this->group_id = null;
        $this->usr_delete = null;
        $this->created_at = null;
        $this->phone = null;
        $this->alreadyInSave = false;
        $this->clearAllReferences();
        $this->applyDefaultValues();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);

        return $this;
    }

    /**
     * Resets all references and back-references to other model objects or collections of model objects.
     *
     * This method is used to reset all php object references (not the actual reference in the database).
     * Necessary for object serialisation.
     *
     * @param bool $deep Whether to also clear the references on all referrer objects.
     * @return $this
     */
    public function clearAllReferences(bool $deep = false)
    {
        if ($deep) {
            if ($this->collClientsUsersRels) {
                foreach ($this->collClientsUsersRels as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collChats) {
                foreach ($this->collChats as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collChatMessages) {
                foreach ($this->collChatMessages as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collClients) {
                foreach ($this->collClients as $o) {
                    $o->clearAllReferences($deep);
                }
            }
        } // if ($deep)

        $this->collClientsUsersRels = null;
        $this->collChats = null;
        $this->collChatMessages = null;
        $this->collClients = null;
        $this->aUserGroup = null;
        return $this;
    }

    /**
     * Return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(UserTableMap::DEFAULT_STRING_FORMAT);
    }

    /**
     * Code to be run before persisting the object
     * @param ConnectionInterface|null $con
     * @return bool
     */
    public function preSave(?ConnectionInterface $con = null): bool
    {
                return true;
    }

    /**
     * Code to be run after persisting the object
     * @param ConnectionInterface|null $con
     * @return void
     */
    public function postSave(?ConnectionInterface $con = null): void
    {
            }

    /**
     * Code to be run before inserting to database
     * @param ConnectionInterface|null $con
     * @return bool
     */
    public function preInsert(?ConnectionInterface $con = null): bool
    {
                return true;
    }

    /**
     * Code to be run after inserting to database
     * @param ConnectionInterface|null $con
     * @return void
     */
    public function postInsert(?ConnectionInterface $con = null): void
    {
            }

    /**
     * Code to be run before updating the object in database
     * @param ConnectionInterface|null $con
     * @return bool
     */
    public function preUpdate(?ConnectionInterface $con = null): bool
    {
                return true;
    }

    /**
     * Code to be run after updating the object in database
     * @param ConnectionInterface|null $con
     * @return void
     */
    public function postUpdate(?ConnectionInterface $con = null): void
    {
            }

    /**
     * Code to be run before deleting the object in database
     * @param ConnectionInterface|null $con
     * @return bool
     */
    public function preDelete(?ConnectionInterface $con = null): bool
    {
                return true;
    }

    /**
     * Code to be run after deleting the object in database
     * @param ConnectionInterface|null $con
     * @return void
     */
    public function postDelete(?ConnectionInterface $con = null): void
    {
            }


    /**
     * Derived method to catches calls to undefined methods.
     *
     * Provides magic import/export method support (fromXML()/toXML(), fromYAML()/toYAML(), etc.).
     * Allows to define default __call() behavior if you overwrite __call()
     *
     * @param string $name
     * @param mixed $params
     *
     * @return array|string
     */
    public function __call($name, $params)
    {
        if (0 === strpos($name, 'get')) {
            $virtualColumn = substr($name, 3);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }

            $virtualColumn = lcfirst($virtualColumn);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }
        }

        if (0 === strpos($name, 'from')) {
            $format = substr($name, 4);
            $inputData = $params[0];
            $keyType = $params[1] ?? TableMap::TYPE_PHPNAME;

            return $this->importFrom($format, $inputData, $keyType);
        }

        if (0 === strpos($name, 'to')) {
            $format = substr($name, 2);
            $includeLazyLoadColumns = $params[0] ?? true;
            $keyType = $params[1] ?? TableMap::TYPE_PHPNAME;

            return $this->exportTo($format, $includeLazyLoadColumns, $keyType);
        }

        throw new BadMethodCallException(sprintf('Call to undefined method: %s.', $name));
    }

}
